init offset = 1

screen say(who, what):
    style_prefix "say"

    window:
        id "window"
        #######Textbox transparency
        background Transform(style.window.background, alpha = 1 - persistent.textbox_transparency)
        ######

        if who is not None:

            window:
                id "namebox"
                style "namebox"
                text who id "who"

        text what id "what" size persistent.pref_text_size


    ## If there's a side image, display it above the text. Do not display on the
    ## phone variant - there's no room.
    if not renpy.variant("small"):
        add SideImage() xalign 0.0 yalign 1.0


screen choice(items):

    style_prefix "choice"

    vbox:
        yalign 0.6
        for n, i in enumerate(items, 1):

            $ hint = i.kwargs.get("hint", "none")

            hbox:
                if persistent.menu_hints and is_there_a_hint(hint) and not _in_replay:
                    xanchor 1.0
                    xpos 1250
                    spacing 60
                    imagebutton auto "images/utility/menu/menu_hint_%s.webp" yalign 0.5 action NullAction() hovered Function(show_menu_hint, hint) unhovered (Hide('notify'), Function(restore_notify_timeout))
                else:
                    xanchor 0.5
                    xalign 0.5
                    spacing 60

                if n < 10:
                    key str(n) action i.action
                    key "K_KP" + str(n) action i.action
                    textbutton str(n) + ". " + i.caption action i.action


init python:
    def _toggle_quick_menu_q():

        if renpy.has_screen('quick_menu'):
            if not hasattr(store, 'quick_menu'):
                setattr(store, 'quick_menu', True)
                renpy.show_screen('quick_menu')
                setattr(store, 'suppress_overlay', False)
            else:
                if quick_menu == True:
                    setattr(store, 'quick_menu', False)
                    renpy.hide_screen('quick_menu')
                else:
                    setattr(store, 'quick_menu', True)
                    renpy.show_screen('quick_menu')
                    setattr(store, 'suppress_overlay', False)

    config.keymap[ 'toggle_quick_menu_q' ] = [ 'K_q' ]
    config.underlay.append(renpy.Keymap(toggle_quick_menu_q = Function(_toggle_quick_menu_q)))


screen preferences():
    tag menu


    use game_menu(_("Preferences"), scroll="viewport"):

        vbox:

            hbox:
                box_wrap True

                if renpy.variant("pc"):

                    vbox:
                        style_prefix "radio"
                        label _("Display")
                        textbutton _("Window") action Preference("display", "window")
                        textbutton _("Fullscreen") action Preference("display", "fullscreen")

                vbox:
                    style_prefix "radio"
                    label _("Rollback Side")
                    textbutton _("Disable") action Preference("rollback side", "disable")
                    textbutton _("Left") action Preference("rollback side", "left")
                    textbutton _("Right") action Preference("rollback side", "right")

                vbox:
                    style_prefix "check"
                    label _("Skip")
                    textbutton _("Unseen Text") action Preference("skip", "toggle")
                    textbutton _("After Choices") action Preference("after choices", "toggle")
                    textbutton _("Transitions") action InvertSelected(Preference("transitions", "toggle"))

                if is_steam_edition:
                    vbox:
                        style_prefix "radio"
                        label _("Taboo Mode")
                        textbutton _("Enabled" ) selected (    persistent.is_special) action SetVariable("persistent.is_special", True )
                        textbutton _("Disabled") selected (not persistent.is_special) action SetVariable("persistent.is_special", False)

            null height (4 * gui.pref_spacing)

            hbox:
                style_prefix "slider"
                box_wrap True

                vbox:

                    label _("Text Speed")

                    bar value Preference("text speed")

                    label _("Auto-Forward Time")

                    bar value Preference("auto-forward time")

                    label _("Textbox Transparency")

                    bar value FieldValue(persistent, "textbox_transparency", range=1.0, style="slider")

                    # Text size
                    label _("Text Size: %s" % (persistent.pref_text_size))

                    bar value FieldValue(object=persistent, field='pref_text_size', range=(gui.text_size * 2), max_is_zero=False, style=u'slider', offset=0, step=1)

                    null height 60
                    textbutton _("Connect Your Toy"):
                        action ShowMenu("lovense_connect")
                        idle_background "images/utility/lovense/lovense_logo_idle.png"
                        hover_background "images/utility/lovense/lovense_logo_hover.png"
                        focus_mask "images/utility/lovense/lovense_button_mask.png"
                        style "lovense_pref_button"

                vbox:

                    if config.has_music:
                        label _("Music Volume")

                        hbox:
                            bar value Preference("music volume")

                    if config.has_sound:

                        label _("Sound Volume")

                        hbox:
                            bar value Preference("sound volume")

                            if config.sample_sound:
                                textbutton _("Test") action Play("sound", config.sample_sound)


                    if config.has_voice and is_extended_edition:
                        label _("Voice Volume")

                        hbox:
                            bar value Preference("voice volume")

                            if config.sample_voice:
                                textbutton _("Test") action Play("voice", config.sample_voice)

                    if config.has_music or config.has_sound or config.has_voice:
                        null height gui.pref_spacing

                        textbutton _("Mute All"):
                            action Preference("all mute", "toggle")
                            style "mute_all_button"

                    if not is_extended_edition:
                        null height 20
                        frame:
                            xsize 525
                            background None
                            text _("Music, Voice and Sound Effects are only implemented in the Extended Edition of the game")